import { ElementRef, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { Color } from 'tns-core-modules/color';
import { Length } from 'tns-core-modules/ui/styling/style-properties';
export declare class NativeRippleDirective implements OnInit, OnChanges, OnDestroy {
    private el;
    private static readonly IOS_RIPPLE_ALPHA;
    ripple: string;
    rippleColor?: string;
    rippleColorAlpha?: number;
    rippleLayer?: "background" | "foreground";
    loaded: boolean;
    initialized: boolean;
    tapFn: any;
    holding: boolean;
    holdAnimation: any;
    private originalNSFn;
    private previousNSFn;
    constructor(el: ElementRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: SimpleChanges): void;
    getRippleColor(): Color;
    getRippleLayer(): "foreground" | "background";
    applyOrRemoveRipple(): void;
    monkeyPatch: (val: any) => void;
    onLoaded(): void;
    onUnloaded(): void;
    getInDP(radius: Length): number;
    applyRipple(): void;
    removeRipple(): void;
    removeHold(): void;
    performRipple(x: number, y: number): void;
    performHold(): void;
    applyOnIOS(): void;
    removeOnIOS(): void;
    applyOnAndroid(): void;
    removeOnAndroid(): void;
}
