import { Color } from 'tns-core-modules/color';
import { ContentView } from 'tns-core-modules/ui/content-view';
import { Property } from 'tns-core-modules/ui/core/properties';
import { AddChildFromBuilder } from 'tns-core-modules/ui/core/view';
export declare class RippleView extends ContentView implements AddChildFromBuilder {
    private rippleHelper;
    private initialized;
    rippleEnabled: boolean;
    rippleColor: string | Color;
    rippleColorAlpha: number | null | undefined;
    rippleLayer: "background" | "foreground" | "auto";
    constructor();
    _addChildFromBuilder(name: string, value: any): void;
    onLoaded(): void;
    disposeNativeView(): void;
    _updateEnabled(): void;
    _updateColor(): void;
    _updateAlpha(): void;
    _updateLayer(): void;
    private initializeRipple();
}
export declare const rippleColorProperty: Property<RippleView, Color>;
export declare const rippleColorAlpha: Property<RippleView, number>;
export declare const rippleLayer: Property<RippleView, "auto" | "background" | "foreground">;
export declare const rippleEnabled: Property<RippleView, boolean>;
