"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var color_1 = require("tns-core-modules/color");
var content_view_1 = require("tns-core-modules/ui/content-view");
var properties_1 = require("tns-core-modules/ui/core/properties");
var view_1 = require("tns-core-modules/ui/core/view");
var ripple_1 = require("./lib/ripple");
var RippleView = /** @class */ (function (_super) {
    __extends(RippleView, _super);
    function RippleView() {
        var _this = _super.call(this) || this;
        _this.initialized = false;
        _this.rippleLayer = "auto";
        return _this;
    }
    RippleView.prototype._addChildFromBuilder = function (name, value) {
        _super.prototype._addChildFromBuilder.call(this, name, value);
        this.initializeRipple();
    };
    RippleView.prototype.onLoaded = function () {
        _super.prototype.onLoaded.call(this);
        this.initializeRipple();
    };
    RippleView.prototype.disposeNativeView = function () {
        if (this.initialized) {
            this.initialized = false;
            this.rippleHelper.dispose();
            this.rippleHelper = undefined;
        }
    };
    RippleView.prototype._updateEnabled = function () {
        if (this.rippleHelper) {
            this.rippleHelper.enabled = this.rippleEnabled;
        }
    };
    RippleView.prototype._updateColor = function () {
        if (this.rippleHelper) {
            this.rippleHelper.color = this.rippleColor;
        }
    };
    RippleView.prototype._updateAlpha = function () {
        if (this.rippleHelper) {
            this.rippleHelper.alpha = this.rippleColorAlpha;
        }
    };
    RippleView.prototype._updateLayer = function () {
        if (this.rippleHelper) {
            this.rippleHelper.rippleLayer = this.rippleLayer;
        }
    };
    RippleView.prototype.initializeRipple = function () {
        if (this.initialized) {
            return;
        }
        if (this.content) {
            this.initialized = true;
            this.rippleHelper = new ripple_1.Ripple(this.content);
            this.rippleHelper.alpha = this.rippleColorAlpha;
            this.rippleHelper.color = this.rippleColor;
            this.rippleHelper.enabled = this.rippleEnabled;
            this.rippleHelper.rippleLayer = this.rippleLayer;
            this.rippleHelper.init();
        }
    };
    return RippleView;
}(content_view_1.ContentView));
exports.RippleView = RippleView;
exports.rippleColorProperty = new properties_1.Property({
    name: 'rippleColor',
    equalityComparer: color_1.Color.equals,
    valueConverter: function (v) { return new color_1.Color(v); },
    valueChanged: function (target) { target._updateColor(); }
});
exports.rippleColorProperty.register(RippleView);
exports.rippleColorAlpha = new properties_1.Property({
    name: 'rippleColorAlpha',
    affectsLayout: false,
    valueConverter: function (v) { return v != null && v !== undefined ? +v : undefined; },
    valueChanged: function (target) { target._updateAlpha(); }
});
exports.rippleColorAlpha.register(RippleView);
exports.rippleLayer = new properties_1.Property({
    name: 'rippleLayer',
    defaultValue: "auto",
    affectsLayout: false,
    valueChanged: function (target) { target._updateLayer(); }
});
exports.rippleLayer.register(RippleView);
exports.rippleEnabled = new properties_1.Property({
    name: 'rippleEnabled',
    defaultValue: true,
    affectsLayout: false,
    valueConverter: view_1.booleanConverter,
    valueChanged: function (target) { target._updateEnabled(); }
});
exports.rippleEnabled.register(RippleView);
